import { jsxs as T, Fragment as F, jsx as w } from "react/jsx-runtime";
import { useFloating as L, autoUpdate as N, arrow as M, offset as U, flip as V, shift as D, useTransitionStyles as j, useHover as B, useFocus as H, useDismiss as W, useRole as q, useInteractions as z, FloatingPortal as G, FloatingArrow as J } from "@floating-ui/react";
import { useState as _, useRef as u, cloneElement as K, useCallback as Q, useEffect as b } from "react";
import n from "clsx";
/*!
  @versini/ui-tooltip v1.1.0
  © 2025 gizmette.com
*/
try {
  window.__VERSINI_UI_TOOLTIP__ || (window.__VERSINI_UI_TOOLTIP__ = {
    version: "1.1.0",
    buildTime: "01/19/2025 01:35 PM EST",
    homepage: "https://github.com/aversini/ui-components",
    license: "MIT"
  });
} catch {
}
const X = "av-tooltip", Y = "av-tooltip-arrow", Z = () => n("w-max py-1 px-2 rounded text-sm"), $ = ({
  mode: t
}) => n({
  "bg-surface-darker": t === "dark" || t === "system",
  "bg-surface-light": t === "light" || t === "alt-system",
  "dark:bg-surface-light": t === "system",
  "dark:bg-surface-darker": t === "alt-system"
}), tt = ({
  mode: t
}) => n({
  "text-copy-light": t === "dark" || t === "system",
  "text-copy-dark": t === "light" || t === "alt-system",
  "dark:text-copy-dark": t === "system",
  "dark:text-copy-light": t === "alt-system"
}), et = ({
  mode: t
}) => n({
  "fill-surface-darker [&>path:first-of-type]:bg-surface-darker [&>path:last-of-type]:bg-surface-darker": t === "dark" || t === "system",
  "fill-surface-light [&>path:first-of-type]:bg-surface-light [&>path:last-of-type]:bg-surface-light": t === "light" || t === "alt-system",
  "dark:fill-surface-light dark:[&>path:first-of-type]:bg-surface-light dark:[&>path:last-of-type]:bg-surface-light": t === "system",
  "dark:fill-surface-darker dark:[&>path:first-of-type]:bg-surface-darker dark:[&>path:last-of-type]:bg-surface-darker": t === "alt-system"
}), st = ({
  mode: t
}) => {
  const e = n(
    X,
    Z(),
    $({ mode: t }),
    tt({ mode: t })
  ), s = n(
    Y,
    et({ mode: t })
  );
  return { tooltip: e, arrow: s };
};
function rt(t, e, s = { active: !0 }) {
  const [p, l] = _(t), o = u(!1), r = u(null), c = u(!1), a = Q(() => {
    const f = r.current;
    f && window.clearTimeout(f);
  }, []);
  return b(() => {
    if (!s.active) {
      l(t);
      return;
    }
    o.current && (a(), r.current = window.setTimeout(() => {
      c.current = !1, l(t);
    }, e));
  }, [t, s, e, a]), b(() => (o.current = !0, a), [a]), [p];
}
const ct = ({
  trigger: t,
  label: e,
  placement: s = "top",
  mode: p = "system",
  initialOpen: l = !1,
  open: o,
  onOpenChange: r,
  delay: c = 300
}) => {
  const [a, f] = _(l), h = o !== void 0;
  h && o === !1 && (c = 0);
  const [g] = rt(
    o ?? a,
    c,
    {
      active: h
    }
  ), x = r ?? f, y = u(null), { refs: k, floatingStyles: I, context: i } = L({
    open: g,
    onOpenChange: (m) => {
      x(m), r == null || r(m);
    },
    placement: s,
    // Make sure the tooltip stays on the screen
    whileElementsMounted: N,
    middleware: [
      M({
        element: y
      }),
      U(11),
      V({
        crossAxis: s.includes("-"),
        fallbackAxisSideDirection: "start"
      }),
      D()
    ]
  }), { styles: R } = j(i), d = st({ mode: p }), S = B(i, { move: !1, delay: { open: c } }), C = H(i), v = W(i, {
    referencePress: !0
  }), A = q(i, { role: "tooltip" }), { getReferenceProps: E, getFloatingProps: P } = z([
    S,
    C,
    v,
    A
  ]), O = K(
    t,
    {
      "aria-label": e,
      "data-open": String(g),
      ref: k.setReference,
      ...E()
    }
  );
  return /* @__PURE__ */ T(F, { children: [
    O,
    /* @__PURE__ */ w(G, { children: g && /* @__PURE__ */ T(
      "div",
      {
        className: d.tooltip,
        ref: k.setFloating,
        style: { ...I, ...R },
        ...P(),
        children: [
          /* @__PURE__ */ w(
            J,
            {
              ref: y,
              context: i,
              className: d.arrow
            }
          ),
          e
        ]
      }
    ) })
  ] });
};
export {
  Y as TOOLTIP_ARROW_CLASSNAME,
  X as TOOLTIP_CLASSNAME,
  ct as Tooltip
};
